/***********************************************************************

 Fast! Keyboard handler.

 Written by:

 Francesco E. Carucci
 Anarchy's Art

 s75926@galileo.polito.it

 /-----------------------------\
 -TRANSLATED IN Borland C++ 3.1-
 -by M.Campinoti               -
 -mrcode@tiscalinet.it         -
 \-----------------------------/

 ***********************************************************************/

#include <stdio.h>
#include <dos.h>
#include <mem.h>
#include "include/svga.h"
#include "include/keybhand.h"

#ifdef __cplusplus
    #define __CPPARGS ...
#else
    #define __CPPARGS
#endif

UBYTE pressed[256]; //array dei tasti
void interrupt (*SaveInt09)(__CPPARGS); //ci salvo dentro il vecchio handler della tastiera

void interrupt KeybHandler(__CPPARGS){

  asm xor ax,ax
  asm in al,0x60
  asm mov di,ax
  asm and di,0x0FF7F
  asm mov bx,7

  asm db 0x0F      //(* cf=bit 7 *)
  asm db 0xA3      //(* if cf=0, al=0. if cf=1, al=0FFh *)
  asm db 0xD8      //istruzioni 386 "undocumented" ..brr
  asm db 0xD6

  asm not al
  asm lea bx,pressed
  asm mov [bx+di],al
  asm mov al,0x20
  asm out 0x20,al
}

void InstallKeybHandler(){

  // inizializzo l'array dei tasti a zero
  setmem(pressed, 256, 0);

  SaveInt09=_dos_getvect(9);	// salvo l'handler della tastiera
  _dos_setvect(9,KeybHandler);
}

void RestoreKeybHandler(){
  _dos_setvect(9,SaveInt09);
}

UBYTE IsPressed(UBYTE AKey){
  return(pressed[AKey]);
}

UBYTE IsReleased(UBYTE AKey){
  return(~pressed[AKey]);
}

void WaitKey (UBYTE AKey){
 while(!IsPressed(AKey));
 while(!IsReleased(AKey));
}