/* INCLUDE per PROTOS Gestione UART        */
/* VER$ 1.00 27/11/97			   */
/*******************************************/


//Prototipi per il detecting
extern WORD cdecl UARTDetectIntlevel(UWORD baseaddr);
extern WORD cdecl UARTDetectType(UWORD baseaddr);
extern void CheckSerialHardware(void);

//General uart access routines
extern WORD cdecl UARTSetRate(UWORD baseaddr, UWORD divisor);
extern WORD cdecl UARTSetLine(UWORD baseaddr, UWORD lineparams);
extern void cdecl UARTSetBreak(UWORD baseaddr);
extern void cdecl UARTClearBreak(UWORD baseaddr);
extern void cdecl UARTSetDTR(UWORD baseaddr);
extern void cdecl UARTClearDTR(UWORD baseaddr);
extern void cdecl UARTSetRTS(UWORD baseaddr);
extern void cdecl UARTClearRTS(UWORD baseaddr);
extern void cdecl UARTSetLocLoopback(UWORD baseaddr);
extern void cdecl UARTClearLocLoopback(UWORD baseaddr);
extern WORD cdecl UARTEnableFifo(UWORD baseaddr, UWORD triggerlevel);
extern void cdecl UARTDisableFifo(UWORD baseaddr);
extern WORD cdecl UARTGetLineStatus(UWORD baseaddr);
extern WORD cdecl UARTGetModemStatus(UWORD baseaddr);
extern WORD cdecl UARTReadScratchReg(unsigned baseaddr);
extern void cdecl UARTWriteScratchReg(unsigned baseaddr, int value);

// Prototypes for interrupt mode operation
extern WORD cdecl UART_INTDefinePort(UWORD baseaddr, UWORD intlevel,
				     UWORD inbuf_size, UWORD outbuf_size,
				     UWORD handshake);
int cdecl uart_int_undef_port(int handle);
int cdecl uart_int_receive_byte(int handle);
extern WORD cdecl UART_INTSendByte(WORD handle, WORD byte);
int cdecl uart_int_set_break(int handle);
int cdecl uart_int_clear_break(int handle);
int cdecl uart_int_set_dtr(int handle);
int cdecl uart_int_clear_dtr(int handle);
int cdecl uart_int_set_rts(int handle);
int cdecl uart_int_clear_rts(int handle);
int cdecl uart_int_set_local_loopback(int handle);
int cdecl uart_int_clear_local_loopback(int handle);
int cdecl uart_int_clear_receive_buffer(int handle);
int cdecl uart_int_clear_send_buffer(int handle);
int cdecl uart_int_set_bps_rate(int handle, unsigned bpsrate);
int cdecl uart_int_set_line_params(int handle, int lineparams);
int cdecl uart_int_read_line_params(int handle);
int cdecl uart_int_write_scr(int handle, int value);
int cdecl uart_int_read_scr(int handle);
extern WORD cdecl UART_INTSendString(WORD handle, BYTE *buf);
extern WORD cdecl UART_INTSendBlock(WORD handle, void *pointer, UWORD count);
int cdecl uart_int_set_handshake(int handle, unsigned handshake);
int cdecl uart_int_set_msi_handler(int handle, void (*msihandler)(int handle, unsigned baseaddr, int msr));
int cdecl uart_int_set_lsi_handler(int handle, void (*lsihandler)(int handle, unsigned baseaddr, int lsr));
int cdecl uart_int_default_handler(int handle, unsigned baseaddr, int value);
void cdecl uart_int_enable(void);
void cdecl uart_int_disable(void);
unsigned cdecl uart_int_get_baseaddr(int handle);
