#include <dos.h>
#include <mem.h>
#include <time.h>
#include <stdlib.h>
#include <conio.h>
#include "include/svga.h"
#include "protos/svga_pr.h"
#include "include/font.h"
#include "include/graph.h"
#include "protos/graph_pr.h"
#include "include/keybhand.h"
#include "protos/keybh_pr.h"


/* dimensioni array per lo ScreenSaver **********/

#define STARS 300
#define DEPTH 1000
#define SCALE 4
#define WIDTH 30000

LONG starx[STARS], stary[STARS], starz[STARS];
WORD oldstarx[STARS], oldstary[STARS];

/************************************************/

void ScreenSaver(UBYTE far* vgamem ,MODEINFOBLOCK* MInfo){

 UWORD y;
 UWORD i0;

 randomize();

   for(i0 = 0; i0 < STARS; i0++) {
      oldstarx[i0] = 0;
      oldstary[i0] = 0;
      starx[i0] = (random(WIDTH) - (WIDTH/2)) * SCALE;
      stary[i0] = (random(WIDTH) - (WIDTH/2)) * SCALE;
      starz[i0] = random(DEPTH)+1;
      }

 ClrSVGA(vgamem,BLACK,MInfo);

 while(!IsPressed(ESC_KEY)){
      for(i0 = 0; i0 < STARS; i0++) {

	 if(((oldstarx[i0]<639)&&(oldstarx[i0]>0))&&((oldstary[i0]<479)&&(oldstary[i0]>0)))
	  PutPixel(oldstarx[i0], oldstary[i0], 0x00,vgamem,MInfo);
	  //RectFill(oldstarx[i0],oldstary[i0],
	  //	   oldstarx[i0]+5,oldstary[i0]+5,
	  //	   0x00,vgamem,&ModeInfo);

	 starz[i0]--;
	 if (starz[i0] == 0) starz[i0] = DEPTH;             // cambiare qui (XRes=640)!!
	 oldstarx[i0] = ((starx[i0] * SCALE) / starz[i0]) + (640/2);
	 oldstary[i0] = ((stary[i0] * SCALE) / starz[i0]) + (MInfo->YResolution/2);
	 if(((oldstarx[i0]<639)&&(oldstarx[i0]>0))&&((oldstary[i0]<479)&&(oldstary[i0]>0)))
	  PutPixel(oldstarx[i0], oldstary[i0],31, vgamem ,MInfo);
	  //RectFill(oldstarx[i0],oldstary[i0],
	  //	   oldstarx[i0]+5,oldstary[i0]+5,
	  //	   72,vgamem,MInfo);

	 }
      }

}