/*INCLUDE FILE for FUNCTION PROTOTYPES  */
/*SVGA.LIB                              */
/*VER$1.00				*/
/*DATE :05/11/97			*/
/****************************************/

extern void SetMode (register UWORD mode);
extern void WaitRetrace(void);
extern UWORD GetVGAInfo (VGAINFOBLOCK* VGABlock);
extern UWORD GetModeInfo (MODEINFOBLOCK* ModeBlock ,UWORD mode );
extern void ClrSVGA (UBYTE far* buffer ,UBYTE colore, MODEINFOBLOCK* MInfo);
extern void SetSVGAMode (register UWORD mode);
extern void SetSVGABank (UWORD bank ,MODEINFOBLOCK* MInfo);
extern void DisplayVESAInfo (VGAINFOBLOCK* VGAInfo);
extern void DisplaySVGAInfo (VGAINFOBLOCK* VGAInfo ,MODEINFOBLOCK* ModeInfo);
extern void DisplayModeInfo (VGAINFOBLOCK* VGAInfo, MODEINFOBLOCK* ModeInfo ,UWORD mode);
extern UWORD SetScanLine(MODEINFOBLOCK* MInfo ,register UWORD width);
extern void SetDisplayStart(UWORD xoff ,UWORD yoff);

//funzioni implementate per le schede CIRRUS LOGIC
extern void CheckCirrus(void);
extern void CLBlank(UBYTE status); //solo per bios V3.02 o successivi
extern void CLRefresh(UBYTE status);
extern UBYTE CLAskChipID(void);

//funzioni per la manipolazione della palette (a 256 colori)
extern void GetPalette(UBYTE colnum ,UBYTE* R ,UBYTE* G ,UBYTE* B);
extern void SetPalette(UBYTE colnum ,UBYTE R ,UBYTE G ,UBYTE B);
extern void BlackOut(void);
extern void GrabPalette(void);
extern void FadeDown(void);
extern void FadeUp(void);
extern void RestorePalette(void);
