#include <stdio.h>
#include <conio.h>
#include <dos.h>
#include <fcntl.h>
#include <io.h>
#include <mem.h>
#include <math.h>
#include "include/svga.h"
#include "protos/svga_pr.h"
#include "include/font.h"
#include "protos/font_pr.h"
#include "include/graph.h"
#include "protos/graph_pr.h"
#include "include/bmp.h"
#include "protos/bmp_pr.h"
#include "protos/scrsav_pr.h"
#include "protos/xms32_pr.h"
#include "include/keybhand.h"
#include "protos/keybh_pr.h"
#include "include/uart.h"
#include "protos/uart_pr.h"
#include "include/pcx.h"
#include "protos/pcx_pr.h"


/* GLOBALS ... meno ci sono e meglio ....lo so'....NON ROMPETEMI!! */

extern unsigned _stklen;
extern UBYTE shbank;

BITMAPFILEHEADER bmfh;
BITMAPINFOHEADER bmih;
RGBQUAD*	 aColors;
UBYTE*           aBitmaps;

UBYTE* startbar[6]={
 "F1=ESCI",
 "F2=COMUNICAZIONI",
 "F3=SCELTA QUADRO",
 "F4=INFORMAZIONI",
 "F5=SYSTEM CHECK",
 0
};

UBYTE* textbar1[4]={
 "F1=MEMORIZZA",
 "F2=STAMPA",
 "F3=INSERISCI VALORI",
 0
};

//declares per i simboli
STRPTR prt="PCX/STAMPANT.PCX";PCXIMAGE prt_img;
STRPTR err="PCX/ERRORE.PCX";PCXIMAGE err_img;
STRPTR ser="PCX/SERIALE.PCX";PCXIMAGE ser_img;
STRPTR keyb="PCX/TASTIERA.PCX";PCXIMAGE keyb_img;
STRPTR arch="PCX/ARCHIVIO.PCX";PCXIMAGE arch_img;
STRPTR arm="PCX/ARMADIO.PCX";PCXIMAGE arm_img;
STRPTR app="PCX/APPUNTI.PCX";PCXIMAGE app_img;


/* Fine dei GLOBALS***************************************************/

int main (void){

 // declares per la svga
 VGAINFOBLOCK VGAInfo={0};
 MODEINFOBLOCK ModeInfo={0};

 UBYTE far* vgamem=(UBYTE far*)MK_FP(0xa000,0); //(punta alla vga)
 UBYTE far* buffp;
 UBYTE far* faddr;

 //declares per i font
 FONTTYPE readable={0};
 FONTTYPE hercital={0};
 FONTTYPE thin_ss ={0};
 FONTTYPE mac     ={0};
 FONTTYPE lcd     ={0};
 FONTTYPE bold    ={0};

 //declares per le finestre
 WINPARAMS mainwin;
 WINPARAMS mainwin2;
 WINPARAMS mainwin3;
 WINPARAMS voltwin;
 WINPARAMS ampwin;
 WINPARAMS coswin;
 WINPARAMS potwin;

 WORD x,y,incx=0,incy=0,error=0;
 UBYTE col=0,type,ch;

 DisplaySVGAInfo(&VGAInfo,&ModeInfo);
 printf("\n..un tasto per continuare\n");
 clrscr();
 while(!kbhit());
 getch();
 return(0);

 if(_Virtual86()){
  printf("Virtual 8086 mode detected !\nRimuovere QEMM o EMM386 e riprovare.\n");
  return(1);
 }

 InitCPU32();
 printf("CPU switched in FLAT REAL MODE (32bit addressing enabled).\n");

 if(XMS32Init()){
  printf("HIMEM.SYS mancante ! (Ver$ 3.00 required).\n");
  return(1);
 }
 printf("Available XMS Memory is %d Kbytes.\n",XMS32QueryFree());

 //modifico la dimensione dello stack a 16kb
 //invece dei 4kb di default
 _stklen=16384U;
 printf("Application Stacklen is %d bytes.\n",_stklen);

 // stampa informazioni sul modo 101 (640x480)
 //DisplayModeInfo(&VGAInfo,&ModeInfo,0x101);
 DisplayVESAInfo(&VGAInfo);

 //guardiamo cosa c'e' nello scatolotto....
 //stampa info's about le seriali installate (max 4 seriali)
 CheckSerialHardware();

 printf("Now loading fonts....");
 LoadFont("FONTS/READABLE.F08",&readable,8);
 LoadFont("FONTS/HERCITAL.F08",&hercital,8);
 LoadFont("FONTS/THIN_SS.F08",&thin_ss,8);
 LoadFont("FONTS/MAC.F08",&mac,8);
 LoadFont("FONTS/LCD.F14",&lcd,14);
 LoadFont("FONTS/BOLD.F14",&bold,14);
 printf("...DONE!\n");

 printf("Now loading symbols....");
 error=LoadPCX(ser,&ser_img);
 if(error) printf("ERROR1 %d\n",error);
 error=LoadPCX(prt,&prt_img);
 if(error) printf("ERROR2 %d\n",error);
 error=LoadPCX(keyb,&keyb_img);
 if(error) printf("ERROR3 %d\n",error);
 error=LoadPCX(arch,&arch_img);
 if(error) printf("ERROR4 %d\n",error);
 error=LoadPCX(err,&err_img);
 if(error) printf("ERROR5 %d\n",error);
 error=LoadPCX(app,&app_img);
 if(error) printf("ERROR6 %d\n",error);
 error=LoadPCX(arm,&arm_img);
 if(error) printf("ERROR7 %d\n",error);
 printf("..DONE!\n");

 //mostra info's sul file pcx dato
 //DisplayPCXInfo (pcxname);

 printf("Installing new Keyboard Handler...");
 InstallKeybHandler();
 printf("..DONE!\n");

 printf("\n[ESC] to continue..");
 WaitKey(ESC_KEY);
 FadeDown();

 GetModeInfo (&ModeInfo,0x101);
 //aggiusta il moltiplicatore per la granularita'
 if(ModeInfo.WinGranularity==4) shbank=4;
  else shbank=0;

 SetSVGAMode(0x101);
 SetScanLine(&ModeInfo,1024U); // setta i pixel per scanline a 1024
 //CLRefresh(HIGH); // High Refresh in 640x480

 /*
 for(y=1;y<16;y++){
  for(x=1;x<16;x++){
	RectFill(incx,incy,40+incx,20+incy,col,vgamem,&ModeInfo);
	PutNumber(incx,incy,col,0,&thin_ss,&ModeInfo);
	col++;
	incx+=40;
	}
       incx=0;
       incy+=20;
       }

 incx=incy=0;

 while(!kbhit());
 getch();
 */

 //carico il background
 LoadBackground("BMP/LOGO.BMP",vgamem,&bmih,&bmfh,&ModeInfo);


 //apro la taskbar
 TaskBar(startbar,vgamem,&readable,&ModeInfo);
 TaskBarTime(&bold,&ModeInfo);

 WaitKey(ESC_KEY);


 TaskBar(textbar1,vgamem,&readable,&ModeInfo);
 TaskBarTime(&bold,&ModeInfo);

 // preparo la finestra
 voltwin.buffp=ampwin.buffp=coswin.buffp=potwin.buffp=mainwin3.buffp=mainwin.buffp=mainwin2.buffp=vgamem;
 voltwin.mode=ampwin.mode=coswin.mode=potwin.mode=mainwin3.mode=mainwin2.mode=mainwin.mode=WIN95;
 voltwin.MInfo=ampwin.MInfo=coswin.MInfo=potwin.MInfo=mainwin3.MInfo=mainwin2.MInfo=mainwin.MInfo=&ModeInfo;
 voltwin.fonttype=ampwin.fonttype=coswin.fonttype=potwin.fonttype=mainwin3.fonttype=mainwin2.fonttype=mainwin.fonttype=&readable;

 voltwin.wintitle="VOLTS(V)";
 OpenWindow(10,40,150,106,&voltwin);
 PutString(voltwin.x,voltwin.y,"L1:",0,-1,&lcd,&ModeInfo);
 PutString(voltwin.x+40,voltwin.y,"216.0",14,40,&lcd,&ModeInfo);voltwin.y+=15;
 PutString(voltwin.x,voltwin.y,"L2:",0,-1,&lcd,&ModeInfo);
 PutString(voltwin.x+40,voltwin.y,"215.0",14,40,&lcd,&ModeInfo);voltwin.y+=15;
 PutString(voltwin.x,voltwin.y,"L3:",0,-1,&lcd,&ModeInfo);
 PutString(voltwin.x+40,voltwin.y,"217.3",14,40,&lcd,&ModeInfo);


 ampwin.wintitle="CORRENTE(Amp)";
 OpenWindow(15,45,625,111,&ampwin);
 PutString(ampwin.x,ampwin.y,"L1:",0,-1,&lcd,&ModeInfo);
 PutString(ampwin.x+40,ampwin.y,"040.0",14,40,&lcd,&ModeInfo);ampwin.y+=15;
 PutString(ampwin.x,ampwin.y,"L2:",0,-1,&lcd,&ModeInfo);
 PutString(ampwin.x+40,ampwin.y,"043.2",14,40,&lcd,&ModeInfo);ampwin.y+=15;
 PutString(ampwin.x,ampwin.y,"L3:",0,-1,&lcd,&ModeInfo);
 PutString(ampwin.x+40,ampwin.y,"041.0",14,40,&lcd,&ModeInfo);

 potwin.wintitle="POTENZA(Kw)";
 OpenWindow(20,50,160,116,&potwin);
 PutString(potwin.x,potwin.y,"L1:",0,-1,&lcd,&ModeInfo);
 PutString(potwin.x+40,potwin.y,"110.0",14,40,&lcd,&ModeInfo);potwin.y+=15;
 PutString(potwin.x,potwin.y,"L2:",0,-1,&lcd,&ModeInfo);
 PutString(potwin.x+40,potwin.y,"210.3",14,40,&lcd,&ModeInfo);potwin.y+=15;
 PutString(potwin.x,potwin.y,"L3:",0,-1,&lcd,&ModeInfo);
 PutString(potwin.x+40,potwin.y,"123.9",14,40,&lcd,&ModeInfo);

 coswin.wintitle="COS-Fi";
 OpenWindow(25,55,165,121,&coswin);
 PutString(coswin.x,coswin.y,"L1:",0,-1,&lcd,&ModeInfo);
 PutString(coswin.x+40,coswin.y,"002.0",14,40,&lcd,&ModeInfo);coswin.y+=15;
 PutString(coswin.x,coswin.y,"L2:",0,-1,&lcd,&ModeInfo);
 PutString(coswin.x+40,coswin.y,"003.5",14,40,&lcd,&ModeInfo);coswin.y+=15;
 PutString(coswin.x,coswin.y,"L3:",0,-1,&lcd,&ModeInfo);
 PutString(coswin.x+40,coswin.y,"002.0",14,40,&lcd,&ModeInfo);

 mainwin.wintitle="CONCATENATA";
 OpenWindow(10,10,600,400,&mainwin);
 /*
 PutString(mainwin.x+40,mainwin.y,"380.0",14,40,&lcd,&ModeInfo);
 PutString(mainwin.x+88,mainwin.y,"Volts",0,-1,&lcd,&ModeInfo);
 PutString(mainwin.x+182,mainwin.y,"045.4",14,40,&lcd,&ModeInfo);
 PutString(mainwin.x+230,mainwin.y,"Ampere",0,-1,&lcd,&ModeInfo);
 PutString(mainwin.x+322,mainwin.y,"320.0",14,40,&lcd,&ModeInfo);
 PutString(mainwin.x+370,mainwin.y,"Kilowatt",0,-1,&lcd,&ModeInfo);
 PutString(mainwin.x+462,mainwin.y,"007.0",14,40,&lcd,&ModeInfo);
 PutString(mainwin.x+510,mainwin.y,"Gradi",0,-1,&lcd,&ModeInfo);
 */

 mainwin2.wintitle="INFO'S";
 OpenWindow(15,15,605,305,&mainwin2);
 /*
 PutString(mainwin2.x+40,mainwin2.y,"380.0",14,40,&lcd,&ModeInfo);
 PutString(mainwin2.x+88,mainwin2.y,"Volts",0,-1,&lcd,&ModeInfo);
 PutString(mainwin2.x+182,mainwin2.y,"045.4",14,40,&lcd,&ModeInfo);
 PutString(mainwin2.x+230,mainwin2.y,"Ampere",0,-1,&lcd,&ModeInfo);
 PutString(mainwin2.x+322,mainwin2.y,"320.0",14,40,&lcd,&ModeInfo);
 PutString(mainwin2.x+370,mainwin2.y,"Kilowatt",0,-1,&lcd,&ModeInfo);
 PutString(mainwin2.x+462,mainwin2.y,"007.0",14,40,&lcd,&ModeInfo);
 PutString(mainwin2.x+510,mainwin2.y,"Gradi",0,-1,&lcd,&ModeInfo);
 */

 mainwin3.wintitle="INFO'S";
 OpenWindow(12,19,615,315,&mainwin3);

 {
  STRPTR stackl;
  STRPTR memfree;

  sprintf(stackl,"Application Stacklen: %d bytes",_stklen);
  sprintf(memfree,"Memoria Libera: %d Kbytes",XMS32QueryFree());
  ErrorWin("SYSTEM MESSAGE","Linea seriale COM1 attiva.",
			     stackl,
			     memfree,
			     &ModeInfo,&readable);
 }

 for (incx=0;incx<495;incx+=33){
  PutSymbol(50+incx,40,&ser_img,&ModeInfo);
  PutSymbol(50+incx,80,&prt_img,&ModeInfo);
  PutSymbol(50+incx,120,&keyb_img,&ModeInfo);
  PutSymbol(50+incx,160,&arch_img,&ModeInfo);
  PutSymbol(50+incx,200,&err_img,&ModeInfo);
  PutSymbol(50+incx,240,&app_img,&ModeInfo);
  PutSymbol(50+incx,280,&arm_img,&ModeInfo);
 }

 WaitKey(ESC_KEY);

 CloseWindow(&mainwin3);//WaitKey(ESC_KEY);
 CloseWindow(&mainwin2);//WaitKey(ESC_KEY);
 CloseWindow(&mainwin);//WaitKey(ESC_KEY);
 CloseWindow(&coswin);//WaitKey(ESC_KEY);
 CloseWindow(&potwin);//WaitKey(ESC_KEY);
 CloseWindow(&ampwin);//WaitKey(ESC_KEY);
 CloseWindow(&voltwin);//WaitKey(ESC_KEY);

 /*
 PutString(126,242,"@1997 by M.Campinoti",1,28,&readable,&ModeInfo);
 PutString(126,251,"e-mail:marco@etruscan.li.it",1,28,&readable,&ModeInfo);
 PutString(126,260,"STAMPA di PROVA [*!$%&/()=*] 1234567890",1,28,&readable,&ModeInfo);

 incy+=9;
 PutString(126,260+incy,"STAMPA di Prova FONT HERCITAL 1234567890",1,-1,&hercital,&ModeInfo);
 incy+=9;
 PutString(126,260+incy,"STAMPA di Prova FONT THIN_SS  1234567890",1,-1,&thin_ss,&ModeInfo);
 incy+=9;
 PutString(126,260+incy,"STAMPA di Prova FONT MAC      1234567890",1,-1,&mac,&ModeInfo);
 incy+=15;
 PutString(126,260+incy,"STAMPA di Prova Font LCD  1234567890",34,-1,&lcd,&ModeInfo);


 incy+=15;
 PutNumber(126,260+incy,(ULONG)&ModeInfo,1,28,&readable,&ModeInfo);
 */

 while(!IsPressed(ESC_KEY)) TaskBarTime(&bold,&ModeInfo);

 FadeDown();
 //ScreenSaver(vgamem,&ModeInfo);
 SetMode(0x03);

 RestoreKeybHandler();

 FreeFontMem(&readable);
 FreeFontMem(&hercital);
 FreeFontMem(&thin_ss);
 FreeFontMem(&mac);
 FreeFontMem(&lcd);
 FreeFontMem(&bold);

 FreePCX(&ser_img);
 FreePCX(&prt_img);
 FreePCX(&keyb_img);
 FreePCX(&arch_img);
 FreePCX(&err_img);
 FreePCX(&app_img);
 FreePCX(&arm_img);

 return(0);
}
